# File: stereocalibfilegen.py
# Company: Modal-AI
# Author: Rich Martin (rich@modalai.com)
# Description: Generates a SNAV stereo calibration XML file using left & right 
# stereo calibration YAML files generated by the ROS DFS calibration tool.

import numpy as np
import sys
import argparse
import decimal
import os.path
import yaml
import xml.etree.ElementTree as et


#coverts float to string without scientific notation
def float_to_str(val):
    ctx = decimal.Context()
    ctx.prec = 15
    dec = ctx.create_decimal(repr(val))

    return format(dec, 'f')


print("Generating SNAV stereo camera calibration . . . ")

yaml_left_default  = "/tmp/calibrationdata/left.yaml";
yaml_right_default = "/tmp/calibrationdata/right.yaml";
xml_snav_default   = "calibration.stereo.xml";

parser = argparse.ArgumentParser(description='Generate SNAV Stereo Calibration File')
parser.add_argument('-l','--yaml_left', dest='l_yaml_file', action='store',
                     default=yaml_left_default,   
                     help = "Left ROS stereo calibration YAML file.") 
parser.add_argument('-r','--yaml_right', dest='r_yaml_file', action='store',
                     default=yaml_right_default,   
                     help = "Right ROS stereo calibration YAML file.") 
parser.add_argument('-x', '--xml_SNAV', dest='snav_xml_file', action='store',
                     default=xml_snav_default,
                    help  = "SNAV stereo calibration template XML file.")
args = parser.parse_args()

#check if files exist before continuing
if not os.path.isfile(args.snav_xml_file):
  sys.exit(args.snav_xml_file + " file not found.");
elif not os.path.isfile(args.r_yaml_file):
  sys.exit(args.r_yaml_file + " file not found.");
elif not os.path.isfile(args.l_yaml_file):
  sys.ext(args.l_yaml_file + " file not found.");
  

#read SNAV calibration XML file
calib = et.parse(args.snav_xml_file)
root  = calib.getroot()

#Read YAML calibration files
with open(args.l_yaml_file, 'r') as ymlfile:
  try:
    left_calib = yaml.load(ymlfile) 
  except yaml.YAMLError as exc:
    sys.exit(exc)

with open(args.r_yaml_file, 'r') as ymlfile:
  try:
    right_calib = yaml.load(ymlfile) 
  except yaml.YAMLError as exc:
    sys.exit(exc)

#right camera
img_w_r = right_calib['image_width']
img_h_r = right_calib['image_height'] 
K_r = right_calib['camera_matrix']['data']
D_r = right_calib['distortion_coefficients']['data']
P_r = np.array(right_calib['projection_matrix']['data'])
R_r = np.array(right_calib['rectification_matrix']['data'])

#left camera
img_w_l = left_calib['image_width']
img_h_l = left_calib['image_height'] 
K_l = left_calib['camera_matrix']['data']
D_l = left_calib['distortion_coefficients']['data']
P_l = np.array(left_calib['projection_matrix']['data'])
R_l = np.array(left_calib['rectification_matrix']['data'])

#parameter substitutions and calcuations originate from the following repository (lines 107 - 177):
#https://github.com/ATLFlight/dfs-ros-example/blob/master/src/nodes/SnapdragonDfsRos.cpp

#right camera parameters
#set principal points
prin_pt_X_r = K_r[2]
prin_pt_Y_r = K_r[5]
#set focal lengths
foc_len_X_r = K_r[0]
foc_len_Y_r = K_r[4]
#set distortion coefficients
distort_coeffs_r = D_r

#left camera parameters
#set principal points
prin_pt_X_l = K_l[2]
prin_pt_Y_l = K_l[5] 
#set focal lengths
foc_len_X_l = K_l[0]
foc_len_Y_l = K_l[4]
#set distortion coefficients
distort_coeffs_l = D_l


#translation calculation
R_r  = R_r.reshape(3,3);
K_prime = np.array([[P_r[0], P_r[1], P_r[2]],
		                [P_r[4], P_r[5], P_r[6]],
                    [P_r[8], P_r[9], P_r[10]]]);
T_prime = np.array([P_r[3], P_r[7], P_r[11]]);
T = np.dot(np.linalg.inv(K_prime),T_prime);


translation = np.dot(R_r.transpose(),T);  

#rotation calculation
rotation = np.array([0, 0, 0]);
rotation_scaled_axis_angle = np.array([0, 0, 0]);
R_l  = R_l.reshape(3,3);
rotation_axis_angle = np.dot(R_r.transpose(), R_l)

angle = np.arccos((rotation_axis_angle[0][0] + rotation_axis_angle[1][1] + rotation_axis_angle[2][2] - 1.0)/2.0);

#angle > 0, else leave rotation at 0 radians (usually for simulations)
if angle > 0:
    x = (rotation_axis_angle[2][1] - rotation_axis_angle[1][2])/np.sqrt(np.power((rotation_axis_angle[2][1] - rotation_axis_angle[1][2]),2)
                                     +np.power((rotation_axis_angle[0][2] - rotation_axis_angle[2][0]),2)
                                     +np.power((rotation_axis_angle[1][0] - rotation_axis_angle[0][1]),2));
    y = (rotation_axis_angle[0][2] - rotation_axis_angle[2][0])/np.sqrt(pow((rotation_axis_angle[2][1] - rotation_axis_angle[1][2]),2)
                                     +np.power((rotation_axis_angle[0][2] - rotation_axis_angle[2][0]),2)
                                     +np.power((rotation_axis_angle[1][0] - rotation_axis_angle[0][1]),2));
    z = (rotation_axis_angle[1][0] - rotation_axis_angle[0][1])/np.sqrt(np.power((rotation_axis_angle[2][1] - rotation_axis_angle[1][2]),2)
                                     +np.power((rotation_axis_angle[0][2] - rotation_axis_angle[2][0]),2)
                                     +np.power((rotation_axis_angle[1][0] - rotation_axis_angle[0][1]),2));
    
    rotation = [np.dot(x,angle), np.dot(y,angle), np.dot(z,angle)];


#left camera parameters
print("Left Image Width: ", img_w_l)
print("Left Image Height: ", img_h_l)
print("Left Principal Point X:", prin_pt_X_l)
print("Left Principal Point Y:", prin_pt_Y_l)
print("Left Focal Length X:",    foc_len_X_l)
print("Left Focal Length Y:",    foc_len_Y_l)
print("Left Distortion Ceoffs:", distort_coeffs_l)

#right camera parameters
print("Right Image Width: ", img_w_r)
print("Right Image Height: ", img_h_r)
print("Right Principal Point X:", prin_pt_X_r)
print("Right Principal Point Y:", prin_pt_Y_r)
print("Right Focal Length X:",    foc_len_X_r)
print("Right Focal Length Y:",    foc_len_Y_r)
print("Right Distortion Coeffs:", distort_coeffs_r)

print("Extrinsic translation:",   translation)   
print("Extrinsic rotation:",      rotation)


#XML Parameters
#set left camera parameters
root.find("./SnavCalibrationStereo/SnavCalibrationLeftStereo/param[@name='calib_pixel_width']").attrib["value"] = str(img_w_l)
root.find("./SnavCalibrationStereo/SnavCalibrationLeftStereo/param[@name='calib_pixel_height']").attrib["value"] = str(img_h_l)

root.find("./SnavCalibrationStereo/SnavCalibrationLeftStereo/param[@name='principal_point_x']").attrib["value"] = float_to_str(prin_pt_X_l)
root.find("./SnavCalibrationStereo/SnavCalibrationLeftStereo/param[@name='principal_point_y']").attrib["value"] = float_to_str(prin_pt_Y_l)

root.find("./SnavCalibrationStereo/SnavCalibrationLeftStereo/param[@name='focal_length_x']").attrib["value"] = float_to_str(foc_len_X_l)
root.find("./SnavCalibrationStereo/SnavCalibrationLeftStereo/param[@name='focal_length_y']").attrib["value"] = float_to_str(foc_len_Y_l)

root.find("./SnavCalibrationStereo/SnavCalibrationLeftStereo/param[@name='distortion_0']").attrib["value"] = float_to_str(distort_coeffs_l[0])
root.find("./SnavCalibrationStereo/SnavCalibrationLeftStereo/param[@name='distortion_1']").attrib["value"] = float_to_str(distort_coeffs_l[1])
root.find("./SnavCalibrationStereo/SnavCalibrationLeftStereo/param[@name='distortion_2']").attrib["value"] = float_to_str(distort_coeffs_l[2])
root.find("./SnavCalibrationStereo/SnavCalibrationLeftStereo/param[@name='distortion_3']").attrib["value"] = float_to_str(distort_coeffs_l[3])

#set right camera parameters
root.find("./SnavCalibrationStereo/SnavCalibrationRightStereo/param[@name='calib_pixel_width']").attrib["value"] = str(img_w_r)
root.find("./SnavCalibrationStereo/SnavCalibrationRightStereo/param[@name='calib_pixel_height']").attrib["value"] = str(img_h_r)

root.find("./SnavCalibrationStereo/SnavCalibrationRightStereo/param[@name='principal_point_x']").attrib["value"] = float_to_str(prin_pt_X_r)
root.find("./SnavCalibrationStereo/SnavCalibrationRightStereo/param[@name='principal_point_y']").attrib["value"] = float_to_str(prin_pt_Y_r)

root.find("./SnavCalibrationStereo/SnavCalibrationRightStereo/param[@name='focal_length_x']").attrib["value"] = float_to_str(foc_len_X_r)
root.find("./SnavCalibrationStereo/SnavCalibrationRightStereo/param[@name='focal_length_y']").attrib["value"] = float_to_str(foc_len_Y_r)

root.find("./SnavCalibrationStereo/SnavCalibrationRightStereo/param[@name='distortion_0']").attrib["value"] = float_to_str(distort_coeffs_r[0])
root.find("./SnavCalibrationStereo/SnavCalibrationRightStereo/param[@name='distortion_1']").attrib["value"] = float_to_str(distort_coeffs_r[1])
root.find("./SnavCalibrationStereo/SnavCalibrationRightStereo/param[@name='distortion_2']").attrib["value"] = float_to_str(distort_coeffs_r[2])
root.find("./SnavCalibrationStereo/SnavCalibrationRightStereo/param[@name='distortion_3']").attrib["value"] = float_to_str(distort_coeffs_r[3])

#set extrinsic parameters
root.find("./SnavCalibrationStereo/param[@name='translation_0']").attrib["value"] = float_to_str(translation[0])
root.find("./SnavCalibrationStereo/param[@name='translation_1']").attrib["value"] = float_to_str(translation[1])
root.find("./SnavCalibrationStereo/param[@name='translation_2']").attrib["value"] = float_to_str(translation[2])

#set rotation parameters
root.find("./SnavCalibrationStereo/param[@name='rotation_0']").attrib["value"] = float_to_str(rotation[0])
root.find("./SnavCalibrationStereo/param[@name='rotation_1']").attrib["value"] = float_to_str(rotation[1])
root.find("./SnavCalibrationStereo/param[@name='rotation_2']").attrib["value"] = float_to_str(rotation[2])

#write XML file
calib.write(args.snav_xml_file)

